#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define PI  3.14159265358979323846

void WritePoly(char *name, float rad, int leaf, int m)
{
    FILE  *dat;
    float step, ang, r, x, y;
    int   max, i;

    if (leaf < 3) {
        printf("Error: 3 <= [number of leaf]");
        return;
    }

    dat = fopen(name, "w");

    if (leaf % 2 == 0) {
        max = leaf * m;
        step = 2.0 * PI / (float)max;
        leaf /= 2;
    }
    else {
        max = leaf * m;
        step = PI / (float)max;
    }

    ang = 0.0;
    for (i = 0; i <= max; i++) {
        r = rad * cos(leaf * ang);
        x = r * cos(ang);
        y = r * sin(ang);
        fprintf(dat, "%f %f %f\n", x, y, 0.0);
        ang += step;
    }
    fclose(dat);
}

void main(int argc, char *argv[])
{
    if (argc < 2)
        printf("Usage : ROSE [output file name] [radius] [number of leaf] [leaf segment]");
    else if (argc < 3)
        WritePoly(argv[1], 10.0, 3, 10);
    else if (argc < 4)
        WritePoly(argv[1], atof(argv[2]), 3, 10);
    else if (argc < 5)
        WritePoly(argv[1], atof(argv[2]), atoi(argv[3]), 10);
    else
        WritePoly(argv[1], atof(argv[2]), atoi(argv[3]), atoi(argv[4]));
}
